   .486
   .model flat, stdcall
   option casemap :none

   include \masm32\include\windows.inc
   include \masm32\include\user32.inc
   include \masm32\include\kernel32.inc
   include \masm32\include\masm32.inc
   include \masm32\macros\macros.asm
   includelib \masm32\lib\masm32.lib
   includelib \masm32\lib\user32.lib
   includelib \masm32\lib\kernel32.lib

   hex2dw proto :DWORD
   show proto :DWORD
      
.data

   buffer   db 30 dup(0)
   string_  db 0   
   string0  db "0",0
   string1  db "1",0
   string2  db "ABCDEF",0
   string3  db "abcdef",0
   string4  db "ffffffff",0

.code
start:
      invoke show,addr string_
      invoke show,addr string0
      invoke show,addr string1
      invoke show,addr string2
      invoke show,addr string3
      invoke show,addr string4
      print SADD(13,10,"Esc to exit, other key for next",13,10,13,10)      
      invoke GetTickCount
      invoke nseed,eax
   next:
      invoke nrandom,0ffffffffh
      invoke nrandom,eax
      mov   ebx,eax
      invoke dw2hex,eax,addr buffer
      print addr buffer
      print SADD(13,10)
      invoke hex2dw,addr buffer
      cmp   eax,ebx
      je    @F
      print SADD("* MISMATCH *",13,10)
   @@:
      call getch
      cmp   eax,27
      jne   next

      print SADD("Press any normal key to exit...")
      call getch
      exit

show proc pString
      print pString
      print SADD(13,10)
      invoke hex2dw,pString
      invoke dw2hex,eax,addr buffer
      print addr buffer
      print SADD(13,10)
      ret
show endp
   
; 
; Table lookup hex string to dword conversion.
;
; Stops converting at first invalid character.
;
; WTEST timing on a P3 with "1234aBcd":
;  129 clocks for this procedure
;  239 clocks for MASM32 htodw
; 
.data
   ; Nibble values indexed by char code.
   hexTable db 48 dup(0ffh)
            db 0,1,2,3,4,5,6,7,8,9  ; '0'-'9'
            db 7 dup(0ffh)
            db 10,11,12,13,14,15    ; 'A'-'F'
            db 26 dup(0ffh)
            db 10,11,12,13,14,15    ; 'a'-'f'
            db 153 dup(0ffh)
.code
hex2dw proc pString:DWORD
      push  esi
      xor   eax,eax
      xor   edx,edx
      mov   esi,pString
      mov   ecx,offset hexTable
   charLoop:
      or    dl,al
      mov   al,[esi]
      inc   esi
      cmp   byte ptr[eax+ecx],0ffh
      mov   al,[eax+ecx]
      je    badChar
      shl   edx,4
      jmp   charLoop
   badChar:
      mov   eax,edx
      pop   esi
      ret
hex2dw endp
; 
getch proc
   ; Waits for and reads a single character from stdin (no echo).
   LOCAL hInput :DWORD
   LOCAL char   :DWORD
   LOCAL bRead  :DWORD

   mov char,0
   invoke GetStdHandle,STD_INPUT_HANDLE
   mov   hInput,eax
   invoke FlushConsoleInputBuffer,hInput
   invoke SetConsoleMode,hInput,ENABLE_PROCESSED_INPUT
   invoke ReadConsole,hInput,ADDR char,1,ADDR bRead,NULL
   invoke SetConsoleMode,hInput,ENABLE_LINE_INPUT or \
                                ENABLE_ECHO_INPUT or \
                                ENABLE_PROCESSED_INPUT
   mov eax,char
   ret
getch endp
; 
end start